/*
 * dv @Version 1.00
 * File:        ad2c.c
 * Target:      PIC18F14K50 48MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2013/10/08 20:00
 *
 * AN5gp
 * OHœd1/3{ɂĐڑ
 * d2.048V
 * ő呪d 2.048*3=6.144V
 * \ 6.144/1024=6mV
 * tADϊlmVPʂœd\
 *
 *              e[q̐ڑ
 *              RC0 out     :LED0
 *              AN5 in      :d1/3
 *              RC2 out     :LCD RS
 *              RC3 out     :LCD E
 *              RC4-RC7 out :LCD DB4-DB7
*/

#include <stdio.h>
#include <p18f14k50.h>
#include <plib\delays.h>
#include "lcd.h"

#pragma config  FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF,MCLRE=OFF

char lcd_buf[34];
void fvr_init(void);

void main(void) {
    ANSEL=0b00100000;    //  AN5gp
    ANSELH=0;
    SLRCON=0;
    WPUB=0;
    INTCON2=0;
    TRISA=0;
    TRISB=0b11110000;
    TRISC=0b00000010;
    lcd_init();
    fvr_init();
    ADCON2=0b10111110;  //  El 20TAD FOSC/64
    ADCON1=0b00001000;  //  t@Xd +=FVR -=VSS
    ADCON0=0b00010101;  //  AN5 ADL

    unsigned adv;
    while(1){
        ADCON0bits.GODONE=1;    //  ϊJn
        while(ADCON0bits.GODONE);   //  ϊI҂
        adv = ADRESH<<8;
        adv += ADRESL;  //  ADϊl10bit

        unsigned  mv =adv*6; // V*2048*3/1024=V*6 mVP
        sprintf(lcd_buf,"ADRES=%i\nVDD=%imV",adv,mv);
        lcd_disp(lcd_buf);
        Delay10KTCYx(200);
        Delay10KTCYx(200);
        Delay10KTCYx(200);
        Delay10KTCYx(200);
        Delay10KTCYx(200);
    }
}

//  t@Xd̐ݒ

void fvr_init(void){
    REFCON0bits.FVR1S1=1;   //  FVR2.048Vɐݒ
    REFCON0bits.FVR1S0=0;
    REFCON0bits.FVR1EN=1;
}
